// This file is generated using the spec version 0.82, firmware template version 1.39and DVR_Parser_0.43
#ifndef _SE_REG_H_INCLUDED_
#define _SE_REG_H_INCLUDED_

//#define  _SE_USE_STRUCT
#ifdef _SE_USE_STRUCT

typedef struct
{
    unsigned int    reserved_0:27;
    unsigned int    se_cmd_swap:1;
    unsigned int    se_reset:1;
    unsigned int    se_idle:1;
    unsigned int    go:1;
    unsigned int    write_data:1;
}se_CNTL;

typedef struct
{
    unsigned int    reserved_0:28;
    unsigned int    coml_empty:1;
    unsigned int    sync:1;
    unsigned int    com_err:1;
    unsigned int    write_data:1;
}se_INT_STATUS;

typedef struct
{
    unsigned int    reserved_0:28;
    unsigned int    coml_empty:1;
    unsigned int    sync:1;
    unsigned int    com_err:1;
    unsigned int    write_data:1;
}se_INT_ENABLE;

typedef struct
{
    unsigned int    reserved_0:16;
    unsigned int    inst_cnt:16;
}se_INST_CNT;

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    cmd_base:27;
}se_CmdBase;

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    cmd_limit:27;
}se_CmdLimit;

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    cmd_rdptr:27;
}se_CmdRDptr;

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    cmd_wr_ptr:27;
}se_CmdWrptr;

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    reserved_1:21;
    unsigned int    cmd_word_ct:6;
}se_CmdFifoState;

typedef struct
{
    unsigned int    reserved_0:8;
    unsigned int    addr_index3:6;
    unsigned int    addr_index2:6;
    unsigned int    addr_index1:6;
    unsigned int    addr_index0:6;
}se_AddrMap;

typedef struct
{
    unsigned int    reserved_0:8;
    unsigned int    color_key:24;
}se_Color_Key;

typedef struct
{
    unsigned int    reserved_0:24;
    unsigned int    def_alpha:8;
}se_Def_Alpha;

typedef struct
{
    unsigned int    reserved_0:24;
    unsigned int    rslt_alpha:8;
}se_Rslt_Alpha;

typedef struct
{
    unsigned int    reserved_0:8;
    unsigned int    def_color:24;
}se_Src_Color;

typedef struct
{
    unsigned int    reserved_0:24;
    unsigned int    src_alpha:8;
}se_Src_Alpha;

typedef struct
{
    unsigned int    reserved_0:29;
    unsigned int    alpha_loc:1;
    unsigned int    color_format:2;
}se_Clr_Format;

typedef struct
{
    unsigned int    reserved_0:24;
    unsigned int    input_value:8;
}se_Input;
#endif

#define SE_CNTL                                                       0x1800C000
#define SE_CNTL_reg_addr                                              "0xB800C000"
#define SE_CNTL_reg                                                   0xB800C000
#define SE_CNTL_inst_addr                                             "0x0000"
#define SE_CNTL_inst                                                  0x0000
#define SE_CNTL_se_cmd_swap_shift                                     (4)
#define SE_CNTL_se_reset_shift                                        (3)
#define SE_CNTL_se_idle_shift                                         (2)
#define SE_CNTL_go_shift                                              (1)
#define SE_CNTL_write_data_shift                                      (0)
#define SE_CNTL_se_cmd_swap_mask                                      (0x00000010)
#define SE_CNTL_se_reset_mask                                         (0x00000008)
#define SE_CNTL_se_idle_mask                                          (0x00000004)
#define SE_CNTL_go_mask                                               (0x00000002)
#define SE_CNTL_write_data_mask                                       (0x00000001)
#define SE_CNTL_se_cmd_swap(data)                                     (0x00000010&((data)<<4))
#define SE_CNTL_se_reset(data)                                        (0x00000008&((data)<<3))
#define SE_CNTL_se_idle(data)                                         (0x00000004&((data)<<2))
#define SE_CNTL_go(data)                                              (0x00000002&((data)<<1))
#define SE_CNTL_write_data(data)                                      (0x00000001&(data))
#define SE_CNTL_get_se_cmd_swap(data)                                 ((0x00000010&(data))>>4)
#define SE_CNTL_get_se_reset(data)                                    ((0x00000008&(data))>>3)
#define SE_CNTL_get_se_idle(data)                                     ((0x00000004&(data))>>2)
#define SE_CNTL_get_go(data)                                          ((0x00000002&(data))>>1)
#define SE_CNTL_get_write_data(data)                                  (0x00000001&(data))

#define SE_INT_STATUS                                                 0x1800C004
#define SE_INT_STATUS_reg_addr                                        "0xB800C004"
#define SE_INT_STATUS_reg                                             0xB800C004
#define SE_INT_STATUS_inst_addr                                       "0x0001"
#define SE_INT_STATUS_inst                                            0x0001
#define SE_INT_STATUS_coml_empty_shift                                (3)
#define SE_INT_STATUS_sync_shift                                      (2)
#define SE_INT_STATUS_com_err_shift                                   (1)
#define SE_INT_STATUS_write_data_shift                                (0)
#define SE_INT_STATUS_coml_empty_mask                                 (0x00000008)
#define SE_INT_STATUS_sync_mask                                       (0x00000004)
#define SE_INT_STATUS_com_err_mask                                    (0x00000002)
#define SE_INT_STATUS_write_data_mask                                 (0x00000001)
#define SE_INT_STATUS_coml_empty(data)                                (0x00000008&((data)<<3))
#define SE_INT_STATUS_sync(data)                                      (0x00000004&((data)<<2))
#define SE_INT_STATUS_com_err(data)                                   (0x00000002&((data)<<1))
#define SE_INT_STATUS_write_data(data)                                (0x00000001&(data))
#define SE_INT_STATUS_get_coml_empty(data)                            ((0x00000008&(data))>>3)
#define SE_INT_STATUS_get_sync(data)                                  ((0x00000004&(data))>>2)
#define SE_INT_STATUS_get_com_err(data)                               ((0x00000002&(data))>>1)
#define SE_INT_STATUS_get_write_data(data)                            (0x00000001&(data))

#define SE_INT_ENABLE                                                 0x1800C008
#define SE_INT_ENABLE_reg_addr                                        "0xB800C008"
#define SE_INT_ENABLE_reg                                             0xB800C008
#define SE_INT_ENABLE_inst_addr                                       "0x0002"
#define SE_INT_ENABLE_inst                                            0x0002
#define SE_INT_ENABLE_coml_empty_shift                                (3)
#define SE_INT_ENABLE_sync_shift                                      (2)
#define SE_INT_ENABLE_com_err_shift                                   (1)
#define SE_INT_ENABLE_write_data_shift                                (0)
#define SE_INT_ENABLE_coml_empty_mask                                 (0x00000008)
#define SE_INT_ENABLE_sync_mask                                       (0x00000004)
#define SE_INT_ENABLE_com_err_mask                                    (0x00000002)
#define SE_INT_ENABLE_write_data_mask                                 (0x00000001)
#define SE_INT_ENABLE_coml_empty(data)                                (0x00000008&((data)<<3))
#define SE_INT_ENABLE_sync(data)                                      (0x00000004&((data)<<2))
#define SE_INT_ENABLE_com_err(data)                                   (0x00000002&((data)<<1))
#define SE_INT_ENABLE_write_data(data)                                (0x00000001&(data))
#define SE_INT_ENABLE_get_coml_empty(data)                            ((0x00000008&(data))>>3)
#define SE_INT_ENABLE_get_sync(data)                                  ((0x00000004&(data))>>2)
#define SE_INT_ENABLE_get_com_err(data)                               ((0x00000002&(data))>>1)
#define SE_INT_ENABLE_get_write_data(data)                            (0x00000001&(data))

#define SE_INST_CNT                                                   0x1800C010
#define SE_INST_CNT_reg_addr                                          "0xB800C010"
#define SE_INST_CNT_reg                                               0xB800C010
#define SE_INST_CNT_inst_addr                                         "0x0004"
#define SE_INST_CNT_inst                                              0x0004
#define SE_INST_CNT_inst_cnt_shift                                    (0)
#define SE_INST_CNT_inst_cnt_mask                                     (0x0000FFFF)
#define SE_INST_CNT_inst_cnt(data)                                    (0x0000FFFF&(data))
#define SE_INST_CNT_get_inst_cnt(data)                                (0x0000FFFF&(data))

#define SE_CmdBase                                                    0x1800C020
#define SE_CmdBase_reg_addr                                           "0xB800C020"
#define SE_CmdBase_reg                                                0xB800C020
#define SE_CmdBase_inst_addr                                          "0x0008"
#define SE_CmdBase_inst                                               0x0008
#define SE_CmdBase_cmd_base_shift                                     (0)
#define SE_CmdBase_cmd_base_mask                                      (0x07FFFFFF)
#define SE_CmdBase_cmd_base(data)                                     (0x07FFFFFF&(data))
#define SE_CmdBase_get_cmd_base(data)                                 (0x07FFFFFF&(data))

#define SE_CmdLimit                                                   0x1800C024
#define SE_CmdLimit_reg_addr                                          "0xB800C024"
#define SE_CmdLimit_reg                                               0xB800C024
#define SE_CmdLimit_inst_addr                                         "0x0009"
#define SE_CmdLimit_inst                                              0x0009
#define SE_CmdLimit_cmd_limit_shift                                   (0)
#define SE_CmdLimit_cmd_limit_mask                                    (0x07FFFFFF)
#define SE_CmdLimit_cmd_limit(data)                                   (0x07FFFFFF&(data))
#define SE_CmdLimit_get_cmd_limit(data)                               (0x07FFFFFF&(data))

#define SE_CmdRDptr                                                   0x1800C028
#define SE_CmdRDptr_reg_addr                                          "0xB800C028"
#define SE_CmdRDptr_reg                                               0xB800C028
#define SE_CmdRDptr_inst_addr                                         "0x000A"
#define SE_CmdRDptr_inst                                              0x000A
#define SE_CmdRDptr_cmd_rdptr_shift                                   (0)
#define SE_CmdRDptr_cmd_rdptr_mask                                    (0x07FFFFFF)
#define SE_CmdRDptr_cmd_rdptr(data)                                   (0x07FFFFFF&(data))
#define SE_CmdRDptr_get_cmd_rdptr(data)                               (0x07FFFFFF&(data))

#define SE_CmdWrptr                                                   0x1800C02C
#define SE_CmdWrptr_reg_addr                                          "0xB800C02C"
#define SE_CmdWrptr_reg                                               0xB800C02C
#define SE_CmdWrptr_inst_addr                                         "0x000B"
#define SE_CmdWrptr_inst                                              0x000B
#define SE_CmdWrptr_cmd_wr_ptr_shift                                  (0)
#define SE_CmdWrptr_cmd_wr_ptr_mask                                   (0x07FFFFFF)
#define SE_CmdWrptr_cmd_wr_ptr(data)                                  (0x07FFFFFF&(data))
#define SE_CmdWrptr_get_cmd_wr_ptr(data)                              (0x07FFFFFF&(data))

#define SE_CmdFifoState                                               0x1800C030
#define SE_CmdFifoState_reg_addr                                      "0xB800C030"
#define SE_CmdFifoState_reg                                           0xB800C030
#define SE_CmdFifoState_inst_addr                                     "0x000C"
#define SE_CmdFifoState_inst                                          0x000C
#define SE_CmdFifoState_cmd_word_ct_shift                             (0)
#define SE_CmdFifoState_cmd_word_ct_mask                              (0x0000003F)
#define SE_CmdFifoState_cmd_word_ct(data)                             (0x0000003F&(data))
#define SE_CmdFifoState_get_cmd_word_ct(data)                         (0x0000003F&(data))

#define SE_AddrMap                                                    0x1800C040
#define SE_AddrMap_reg_addr                                           "0xB800C040"
#define SE_AddrMap_reg                                                0xB800C040
#define SE_AddrMap_inst_addr                                          "0x0010"
#define SE_AddrMap_inst                                               0x0010
#define SE_AddrMap_addr_index3_shift                                  (18)
#define SE_AddrMap_addr_index2_shift                                  (12)
#define SE_AddrMap_addr_index1_shift                                  (6)
#define SE_AddrMap_addr_index0_shift                                  (0)
#define SE_AddrMap_addr_index3_mask                                   (0x00FC0000)
#define SE_AddrMap_addr_index2_mask                                   (0x0003F000)
#define SE_AddrMap_addr_index1_mask                                   (0x00000FC0)
#define SE_AddrMap_addr_index0_mask                                   (0x0000003F)
#define SE_AddrMap_addr_index3(data)                                  (0x00FC0000&((data)<<18))
#define SE_AddrMap_addr_index2(data)                                  (0x0003F000&((data)<<12))
#define SE_AddrMap_addr_index1(data)                                  (0x00000FC0&((data)<<6))
#define SE_AddrMap_addr_index0(data)                                  (0x0000003F&(data))
#define SE_AddrMap_get_addr_index3(data)                              ((0x00FC0000&(data))>>18)
#define SE_AddrMap_get_addr_index2(data)                              ((0x0003F000&(data))>>12)
#define SE_AddrMap_get_addr_index1(data)                              ((0x00000FC0&(data))>>6)
#define SE_AddrMap_get_addr_index0(data)                              (0x0000003F&(data))

#define SE_Color_Key                                                  0x1800C044
#define SE_Color_Key_reg_addr                                         "0xB800C044"
#define SE_Color_Key_reg                                              0xB800C044
#define SE_Color_Key_inst_addr                                        "0x0011"
#define SE_Color_Key_inst                                             0x0011
#define SE_Color_Key_color_key_shift                                  (0)
#define SE_Color_Key_color_key_mask                                   (0x00FFFFFF)
#define SE_Color_Key_color_key(data)                                  (0x00FFFFFF&(data))
#define SE_Color_Key_get_color_key(data)                              (0x00FFFFFF&(data))

#define SE_Def_Alpha                                                  0x1800C048
#define SE_Def_Alpha_reg_addr                                         "0xB800C048"
#define SE_Def_Alpha_reg                                              0xB800C048
#define SE_Def_Alpha_inst_addr                                        "0x0012"
#define SE_Def_Alpha_inst                                             0x0012
#define SE_Def_Alpha_def_alpha_shift                                  (0)
#define SE_Def_Alpha_def_alpha_mask                                   (0x000000FF)
#define SE_Def_Alpha_def_alpha(data)                                  (0x000000FF&(data))
#define SE_Def_Alpha_get_def_alpha(data)                              (0x000000FF&(data))

#define SE_Rslt_Alpha                                                 0x1800C04C
#define SE_Rslt_Alpha_reg_addr                                        "0xB800C04C"
#define SE_Rslt_Alpha_reg                                             0xB800C04C
#define SE_Rslt_Alpha_inst_addr                                       "0x0013"
#define SE_Rslt_Alpha_inst                                            0x0013
#define SE_Rslt_Alpha_rslt_alpha_shift                                (0)
#define SE_Rslt_Alpha_rslt_alpha_mask                                 (0x000000FF)
#define SE_Rslt_Alpha_rslt_alpha(data)                                (0x000000FF&(data))
#define SE_Rslt_Alpha_get_rslt_alpha(data)                            (0x000000FF&(data))

#define SE_Src_Color                                                  0x1800C050
#define SE_Src_Color_reg_addr                                         "0xB800C050"
#define SE_Src_Color_reg                                              0xB800C050
#define SE_Src_Color_inst_addr                                        "0x0014"
#define SE_Src_Color_inst                                             0x0014
#define SE_Src_Color_def_color_shift                                  (0)
#define SE_Src_Color_def_color_mask                                   (0x00FFFFFF)
#define SE_Src_Color_def_color(data)                                  (0x00FFFFFF&(data))
#define SE_Src_Color_get_def_color(data)                              (0x00FFFFFF&(data))

#define SE_Src_Alpha                                                  0x1800C054
#define SE_Src_Alpha_reg_addr                                         "0xB800C054"
#define SE_Src_Alpha_reg                                              0xB800C054
#define SE_Src_Alpha_inst_addr                                        "0x0015"
#define SE_Src_Alpha_inst                                             0x0015
#define SE_Src_Alpha_src_alpha_shift                                  (0)
#define SE_Src_Alpha_src_alpha_mask                                   (0x000000FF)
#define SE_Src_Alpha_src_alpha(data)                                  (0x000000FF&(data))
#define SE_Src_Alpha_get_src_alpha(data)                              (0x000000FF&(data))

#define SE_Clr_Format                                                 0x1800C058
#define SE_Clr_Format_reg_addr                                        "0xB800C058"
#define SE_Clr_Format_reg                                             0xB800C058
#define SE_Clr_Format_inst_addr                                       "0x0016"
#define SE_Clr_Format_inst                                            0x0016
#define SE_Clr_Format_alpha_loc_shift                                 (2)
#define SE_Clr_Format_color_format_shift                              (0)
#define SE_Clr_Format_alpha_loc_mask                                  (0x00000004)
#define SE_Clr_Format_color_format_mask                               (0x00000003)
#define SE_Clr_Format_alpha_loc(data)                                 (0x00000004&((data)<<2))
#define SE_Clr_Format_color_format(data)                              (0x00000003&(data))
#define SE_Clr_Format_get_alpha_loc(data)                             ((0x00000004&(data))>>2)
#define SE_Clr_Format_get_color_format(data)                          (0x00000003&(data))

#define SE_Input                                                      0x1800C05C
#define SE_Input_reg_addr                                             "0xB800C05C"
#define SE_Input_reg                                                  0xB800C05C
#define SE_Input_inst_addr                                            "0x0017"
#define SE_Input_inst                                                 0x0017
#define SE_Input_input_value_shift                                    (0)
#define SE_Input_input_value_mask                                     (0x000000FF)
#define SE_Input_input_value(data)                                    (0x000000FF&(data))
#define SE_Input_get_input_value(data)                                (0x000000FF&(data))
#endif
