// This file is generated using the spec version 0.92, firmware template version 1.39and DVR_Parser_0.4
#ifndef _VC_REG_H_INCLUDED_
#define _VC_REG_H_INCLUDED_

//#define  _VC_USE_STRUCT
#ifdef _VC_USE_STRUCT

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    src:24;
    unsigned int    reserved_1:3;
}vc_DMA_SRC;

typedef struct
{
    unsigned int    reserved_0:5;
    unsigned int    dst:24;
    unsigned int    reserved_1:3;
}vc_DMA_DST;

typedef struct
{
    unsigned int    reserved_0:16;
    unsigned int    valid:1;
    unsigned int    dir:1;
    unsigned int    size:11;
    unsigned int    reserved_1:3;
}vc_DMA_SIZE;

typedef struct
{
    unsigned int    reserved_0:24;
    unsigned int    done_7:1;
    unsigned int    done_6:1;
    unsigned int    done_5:1;
    unsigned int    done_4:1;
    unsigned int    done_3:1;
    unsigned int    done_2:1;
    unsigned int    done_1:1;
    unsigned int    done_0:1;
}vc_DMA_STATUS;

typedef struct
{
    unsigned int    reserved_0:13;
    unsigned int    write_enable1:1;
    unsigned int    max_xfer:7;
    unsigned int    reserved_1:5;
    unsigned int    write_enable3:1;
    unsigned int    dmem_req_en:1;
    unsigned int    write_enable4:1;
    unsigned int    stop:1;
    unsigned int    write_enable5:1;
    unsigned int    go:1;
}vc_DMA_CNTL;

typedef struct
{
    unsigned int    reserved_0:31;
    unsigned int    int_done:1;
}vc_DMA_INT;

typedef struct
{
    unsigned int    reserved_0:31;
    unsigned int    int_done_en:1;
}vc_DMA_INT_EN;

typedef struct
{
    unsigned int    busy_cyc:32;
}vc_DMEM_BUSY;
#endif

#define VC_DMA_SRC_0                                                  0x18001000
#define VC_DMA_SRC_1                                                  0x18001004
#define VC_DMA_SRC_2                                                  0x18001008
#define VC_DMA_SRC_3                                                  0x1800100C
#define VC_DMA_SRC_4                                                  0x18001010
#define VC_DMA_SRC_5                                                  0x18001014
#define VC_DMA_SRC_6                                                  0x18001018
#define VC_DMA_SRC_7                                                  0x1800101C
#define VC_DMA_SRC_0_reg_addr                                         "0xB8001000"
#define VC_DMA_SRC_1_reg_addr                                         "0xB8001004"
#define VC_DMA_SRC_2_reg_addr                                         "0xB8001008"
#define VC_DMA_SRC_3_reg_addr                                         "0xB800100C"
#define VC_DMA_SRC_4_reg_addr                                         "0xB8001010"
#define VC_DMA_SRC_5_reg_addr                                         "0xB8001014"
#define VC_DMA_SRC_6_reg_addr                                         "0xB8001018"
#define VC_DMA_SRC_7_reg_addr                                         "0xB800101C"
#define VC_DMA_SRC_0_reg                                              0xB8001000
#define VC_DMA_SRC_1_reg                                              0xB8001004
#define VC_DMA_SRC_2_reg                                              0xB8001008
#define VC_DMA_SRC_3_reg                                              0xB800100C
#define VC_DMA_SRC_4_reg                                              0xB8001010
#define VC_DMA_SRC_5_reg                                              0xB8001014
#define VC_DMA_SRC_6_reg                                              0xB8001018
#define VC_DMA_SRC_7_reg                                              0xB800101C
#define VC_DMA_SRC_0_inst_addr                                        "0x0000"
#define VC_DMA_SRC_0_inst                                             0x0000
#define VC_DMA_SRC_1_inst_addr                                        "0x0001"
#define VC_DMA_SRC_1_inst                                             0x0001
#define VC_DMA_SRC_2_inst_addr                                        "0x0002"
#define VC_DMA_SRC_2_inst                                             0x0002
#define VC_DMA_SRC_3_inst_addr                                        "0x0003"
#define VC_DMA_SRC_3_inst                                             0x0003
#define VC_DMA_SRC_4_inst_addr                                        "0x0004"
#define VC_DMA_SRC_4_inst                                             0x0004
#define VC_DMA_SRC_5_inst_addr                                        "0x0005"
#define VC_DMA_SRC_5_inst                                             0x0005
#define VC_DMA_SRC_6_inst_addr                                        "0x0006"
#define VC_DMA_SRC_6_inst                                             0x0006
#define VC_DMA_SRC_7_inst_addr                                        "0x0007"
#define VC_DMA_SRC_7_inst                                             0x0007
#define VC_DMA_SRC_src_shift                                          (3)
#define VC_DMA_SRC_src_mask                                           (0x07FFFFF8)
#define VC_DMA_SRC_src(data)                                          (0x07FFFFF8&((data)<<3))
#define VC_DMA_SRC_get_src(data)                                      ((0x07FFFFF8&(data))>>3)

#define VC_DMA_DST_0                                                  0x18001020
#define VC_DMA_DST_1                                                  0x18001024
#define VC_DMA_DST_2                                                  0x18001028
#define VC_DMA_DST_3                                                  0x1800102C
#define VC_DMA_DST_4                                                  0x18001030
#define VC_DMA_DST_5                                                  0x18001034
#define VC_DMA_DST_6                                                  0x18001038
#define VC_DMA_DST_7                                                  0x1800103C
#define VC_DMA_DST_0_reg_addr                                         "0xB8001020"
#define VC_DMA_DST_1_reg_addr                                         "0xB8001024"
#define VC_DMA_DST_2_reg_addr                                         "0xB8001028"
#define VC_DMA_DST_3_reg_addr                                         "0xB800102C"
#define VC_DMA_DST_4_reg_addr                                         "0xB8001030"
#define VC_DMA_DST_5_reg_addr                                         "0xB8001034"
#define VC_DMA_DST_6_reg_addr                                         "0xB8001038"
#define VC_DMA_DST_7_reg_addr                                         "0xB800103C"
#define VC_DMA_DST_0_reg                                              0xB8001020
#define VC_DMA_DST_1_reg                                              0xB8001024
#define VC_DMA_DST_2_reg                                              0xB8001028
#define VC_DMA_DST_3_reg                                              0xB800102C
#define VC_DMA_DST_4_reg                                              0xB8001030
#define VC_DMA_DST_5_reg                                              0xB8001034
#define VC_DMA_DST_6_reg                                              0xB8001038
#define VC_DMA_DST_7_reg                                              0xB800103C
#define VC_DMA_DST_0_inst_addr                                        "0x0008"
#define VC_DMA_DST_0_inst                                             0x0008
#define VC_DMA_DST_1_inst_addr                                        "0x0009"
#define VC_DMA_DST_1_inst                                             0x0009
#define VC_DMA_DST_2_inst_addr                                        "0x000A"
#define VC_DMA_DST_2_inst                                             0x000A
#define VC_DMA_DST_3_inst_addr                                        "0x000B"
#define VC_DMA_DST_3_inst                                             0x000B
#define VC_DMA_DST_4_inst_addr                                        "0x000C"
#define VC_DMA_DST_4_inst                                             0x000C
#define VC_DMA_DST_5_inst_addr                                        "0x000D"
#define VC_DMA_DST_5_inst                                             0x000D
#define VC_DMA_DST_6_inst_addr                                        "0x000E"
#define VC_DMA_DST_6_inst                                             0x000E
#define VC_DMA_DST_7_inst_addr                                        "0x000F"
#define VC_DMA_DST_7_inst                                             0x000F
#define VC_DMA_DST_dst_shift                                          (3)
#define VC_DMA_DST_dst_mask                                           (0x07FFFFF8)
#define VC_DMA_DST_dst(data)                                          (0x07FFFFF8&((data)<<3))
#define VC_DMA_DST_get_dst(data)                                      ((0x07FFFFF8&(data))>>3)

#define VC_DMA_SIZE_0                                                 0x18001040
#define VC_DMA_SIZE_1                                                 0x18001044
#define VC_DMA_SIZE_2                                                 0x18001048
#define VC_DMA_SIZE_3                                                 0x1800104C
#define VC_DMA_SIZE_4                                                 0x18001050
#define VC_DMA_SIZE_5                                                 0x18001054
#define VC_DMA_SIZE_6                                                 0x18001058
#define VC_DMA_SIZE_7                                                 0x1800105C
#define VC_DMA_SIZE_0_reg_addr                                        "0xB8001040"
#define VC_DMA_SIZE_1_reg_addr                                        "0xB8001044"
#define VC_DMA_SIZE_2_reg_addr                                        "0xB8001048"
#define VC_DMA_SIZE_3_reg_addr                                        "0xB800104C"
#define VC_DMA_SIZE_4_reg_addr                                        "0xB8001050"
#define VC_DMA_SIZE_5_reg_addr                                        "0xB8001054"
#define VC_DMA_SIZE_6_reg_addr                                        "0xB8001058"
#define VC_DMA_SIZE_7_reg_addr                                        "0xB800105C"
#define VC_DMA_SIZE_0_reg                                             0xB8001040
#define VC_DMA_SIZE_1_reg                                             0xB8001044
#define VC_DMA_SIZE_2_reg                                             0xB8001048
#define VC_DMA_SIZE_3_reg                                             0xB800104C
#define VC_DMA_SIZE_4_reg                                             0xB8001050
#define VC_DMA_SIZE_5_reg                                             0xB8001054
#define VC_DMA_SIZE_6_reg                                             0xB8001058
#define VC_DMA_SIZE_7_reg                                             0xB800105C
#define VC_DMA_SIZE_0_inst_addr                                       "0x0010"
#define VC_DMA_SIZE_0_inst                                            0x0010
#define VC_DMA_SIZE_1_inst_addr                                       "0x0011"
#define VC_DMA_SIZE_1_inst                                            0x0011
#define VC_DMA_SIZE_2_inst_addr                                       "0x0012"
#define VC_DMA_SIZE_2_inst                                            0x0012
#define VC_DMA_SIZE_3_inst_addr                                       "0x0013"
#define VC_DMA_SIZE_3_inst                                            0x0013
#define VC_DMA_SIZE_4_inst_addr                                       "0x0014"
#define VC_DMA_SIZE_4_inst                                            0x0014
#define VC_DMA_SIZE_5_inst_addr                                       "0x0015"
#define VC_DMA_SIZE_5_inst                                            0x0015
#define VC_DMA_SIZE_6_inst_addr                                       "0x0016"
#define VC_DMA_SIZE_6_inst                                            0x0016
#define VC_DMA_SIZE_7_inst_addr                                       "0x0017"
#define VC_DMA_SIZE_7_inst                                            0x0017
#define VC_DMA_SIZE_valid_shift                                       (15)
#define VC_DMA_SIZE_dir_shift                                         (14)
#define VC_DMA_SIZE_size_shift                                        (3)
#define VC_DMA_SIZE_valid_mask                                        (0x00008000)
#define VC_DMA_SIZE_dir_mask                                          (0x00004000)
#define VC_DMA_SIZE_size_mask                                         (0x00003FF8)
#define VC_DMA_SIZE_valid(data)                                       (0x00008000&((data)<<15))
#define VC_DMA_SIZE_dir(data)                                         (0x00004000&((data)<<14))
#define VC_DMA_SIZE_size(data)                                        (0x00003FF8&((data)<<3))
#define VC_DMA_SIZE_get_valid(data)                                   ((0x00008000&(data))>>15)
#define VC_DMA_SIZE_get_dir(data)                                     ((0x00004000&(data))>>14)
#define VC_DMA_SIZE_get_size(data)                                    ((0x00003FF8&(data))>>3)

#define VC_DMA_STATUS                                                 0x18001060
#define VC_DMA_STATUS_reg_addr                                        "0xB8001060"
#define VC_DMA_STATUS_reg                                             0xB8001060
#define VC_DMA_STATUS_inst_addr                                       "0x0018"
#define VC_DMA_STATUS_inst                                            0x0018
#define VC_DMA_STATUS_done_7_shift                                    (7)
#define VC_DMA_STATUS_done_6_shift                                    (6)
#define VC_DMA_STATUS_done_5_shift                                    (5)
#define VC_DMA_STATUS_done_4_shift                                    (4)
#define VC_DMA_STATUS_done_3_shift                                    (3)
#define VC_DMA_STATUS_done_2_shift                                    (2)
#define VC_DMA_STATUS_done_1_shift                                    (1)
#define VC_DMA_STATUS_done_0_shift                                    (0)
#define VC_DMA_STATUS_done_7_mask                                     (0x00000080)
#define VC_DMA_STATUS_done_6_mask                                     (0x00000040)
#define VC_DMA_STATUS_done_5_mask                                     (0x00000020)
#define VC_DMA_STATUS_done_4_mask                                     (0x00000010)
#define VC_DMA_STATUS_done_3_mask                                     (0x00000008)
#define VC_DMA_STATUS_done_2_mask                                     (0x00000004)
#define VC_DMA_STATUS_done_1_mask                                     (0x00000002)
#define VC_DMA_STATUS_done_0_mask                                     (0x00000001)
#define VC_DMA_STATUS_done_7(data)                                    (0x00000080&((data)<<7))
#define VC_DMA_STATUS_done_6(data)                                    (0x00000040&((data)<<6))
#define VC_DMA_STATUS_done_5(data)                                    (0x00000020&((data)<<5))
#define VC_DMA_STATUS_done_4(data)                                    (0x00000010&((data)<<4))
#define VC_DMA_STATUS_done_3(data)                                    (0x00000008&((data)<<3))
#define VC_DMA_STATUS_done_2(data)                                    (0x00000004&((data)<<2))
#define VC_DMA_STATUS_done_1(data)                                    (0x00000002&((data)<<1))
#define VC_DMA_STATUS_done_0(data)                                    (0x00000001&(data))
#define VC_DMA_STATUS_get_done_7(data)                                ((0x00000080&(data))>>7)
#define VC_DMA_STATUS_get_done_6(data)                                ((0x00000040&(data))>>6)
#define VC_DMA_STATUS_get_done_5(data)                                ((0x00000020&(data))>>5)
#define VC_DMA_STATUS_get_done_4(data)                                ((0x00000010&(data))>>4)
#define VC_DMA_STATUS_get_done_3(data)                                ((0x00000008&(data))>>3)
#define VC_DMA_STATUS_get_done_2(data)                                ((0x00000004&(data))>>2)
#define VC_DMA_STATUS_get_done_1(data)                                ((0x00000002&(data))>>1)
#define VC_DMA_STATUS_get_done_0(data)                                (0x00000001&(data))

#define VC_DMA_CNTL                                                   0x18001064
#define VC_DMA_CNTL_reg_addr                                          "0xB8001064"
#define VC_DMA_CNTL_reg                                               0xB8001064
#define VC_DMA_CNTL_inst_addr                                         "0x0019"
#define VC_DMA_CNTL_inst                                              0x0019
#define VC_DMA_CNTL_write_enable1_shift                               (18)
#define VC_DMA_CNTL_max_xfer_shift                                    (11)
#define VC_DMA_CNTL_write_enable3_shift                               (5)
#define VC_DMA_CNTL_dmem_req_en_shift                                 (4)
#define VC_DMA_CNTL_write_enable4_shift                               (3)
#define VC_DMA_CNTL_stop_shift                                        (2)
#define VC_DMA_CNTL_write_enable5_shift                               (1)
#define VC_DMA_CNTL_go_shift                                          (0)
#define VC_DMA_CNTL_write_enable1_mask                                (0x00040000)
#define VC_DMA_CNTL_max_xfer_mask                                     (0x0003F800)
#define VC_DMA_CNTL_write_enable3_mask                                (0x00000020)
#define VC_DMA_CNTL_dmem_req_en_mask                                  (0x00000010)
#define VC_DMA_CNTL_write_enable4_mask                                (0x00000008)
#define VC_DMA_CNTL_stop_mask                                         (0x00000004)
#define VC_DMA_CNTL_write_enable5_mask                                (0x00000002)
#define VC_DMA_CNTL_go_mask                                           (0x00000001)
#define VC_DMA_CNTL_write_enable1(data)                               (0x00040000&((data)<<18))
#define VC_DMA_CNTL_max_xfer(data)                                    (0x0003F800&((data)<<11))
#define VC_DMA_CNTL_write_enable3(data)                               (0x00000020&((data)<<5))
#define VC_DMA_CNTL_dmem_req_en(data)                                 (0x00000010&((data)<<4))
#define VC_DMA_CNTL_write_enable4(data)                               (0x00000008&((data)<<3))
#define VC_DMA_CNTL_stop(data)                                        (0x00000004&((data)<<2))
#define VC_DMA_CNTL_write_enable5(data)                               (0x00000002&((data)<<1))
#define VC_DMA_CNTL_go(data)                                          (0x00000001&(data))
#define VC_DMA_CNTL_get_write_enable1(data)                           ((0x00040000&(data))>>18)
#define VC_DMA_CNTL_get_max_xfer(data)                                ((0x0003F800&(data))>>11)
#define VC_DMA_CNTL_get_write_enable3(data)                           ((0x00000020&(data))>>5)
#define VC_DMA_CNTL_get_dmem_req_en(data)                             ((0x00000010&(data))>>4)
#define VC_DMA_CNTL_get_write_enable4(data)                           ((0x00000008&(data))>>3)
#define VC_DMA_CNTL_get_stop(data)                                    ((0x00000004&(data))>>2)
#define VC_DMA_CNTL_get_write_enable5(data)                           ((0x00000002&(data))>>1)
#define VC_DMA_CNTL_get_go(data)                                      (0x00000001&(data))

#define VC_DMA_INT                                                    0x18001068
#define VC_DMA_INT_reg_addr                                           "0xB8001068"
#define VC_DMA_INT_reg                                                0xB8001068
#define VC_DMA_INT_inst_addr                                          "0x001A"
#define VC_DMA_INT_inst                                               0x001A
#define VC_DMA_INT_int_done_shift                                     (0)
#define VC_DMA_INT_int_done_mask                                      (0x00000001)
#define VC_DMA_INT_int_done(data)                                     (0x00000001&(data))
#define VC_DMA_INT_get_int_done(data)                                 (0x00000001&(data))

#define VC_DMA_INT_EN                                                 0x1800106C
#define VC_DMA_INT_EN_reg_addr                                        "0xB800106C"
#define VC_DMA_INT_EN_reg                                             0xB800106C
#define VC_DMA_INT_EN_inst_addr                                       "0x001B"
#define VC_DMA_INT_EN_inst                                            0x001B
#define VC_DMA_INT_EN_int_done_en_shift                               (0)
#define VC_DMA_INT_EN_int_done_en_mask                                (0x00000001)
#define VC_DMA_INT_EN_int_done_en(data)                               (0x00000001&(data))
#define VC_DMA_INT_EN_get_int_done_en(data)                           (0x00000001&(data))

#define VC_DMEM_BUSY                                                  0x18001074
#define VC_DMEM_BUSY_reg_addr                                         "0xB8001074"
#define VC_DMEM_BUSY_reg                                              0xB8001074
#define VC_DMEM_BUSY_inst_addr                                        "0x001D"
#define VC_DMEM_BUSY_inst                                             0x001D
#define VC_DMEM_BUSY_busy_cyc_shift                                   (0)
#define VC_DMEM_BUSY_busy_cyc_mask                                    (0xFFFFFFFF)
#define VC_DMEM_BUSY_busy_cyc(data)                                   (0xFFFFFFFF&(data))
#define VC_DMEM_BUSY_get_busy_cyc(data)                               (0xFFFFFFFF&(data))
#endif
